# ListboxTest.py
"""Test the Listbox widget with event handling"""

from Tkinter import *

class Application(Frame):
    def __init__(self, master=None):
        Frame.__init__(self, master)
        top = self.winfo_toplevel()         # find top-level window
        top.title("Listbox Example")
        
        self.grid()
        self.createWidgets()

    def createWidgets(self):
        self.prompt = Label(self, text="Select your favorite animals (select all that apply):")
        self.prompt.grid(row=0, sticky=W+E)
        self.yScroll = Scrollbar(self, orient=VERTICAL)
        self.yScroll.grid(row=1, column=1,sticky=N+S)

        self.xScroll = Scrollbar(self, orient=HORIZONTAL)
        self.xScroll.grid(row=2, column=0,sticky=E+W)

        self.myListbox = Listbox(self, xscrollcommand=self.xScroll.set,
                                 yscrollcommand=self.yScroll.set,
                                 selectmode=MULTIPLE)
        
        self.myListbox.grid(row=1, column=0, sticky=N+S+E+W)
        animals = ['cat', 'dog', 'mouseeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee',
                   'rat', 'fish']
        for animal in animals:
            self.myListbox.insert(END, animal)

        self.xScroll["command"] = self.myListbox.xview
        self.yScroll["command"] = self.myListbox.yview
        self.doneButton = Button(self, text='Click when \n done',
                                 command=self.readSelections)
        self.doneButton.grid(row=3)

    def readSelections(self):
        selectionsTuple = self.myListbox.curselection()
        print selectionsTuple
        print "Favorite Animals:"
        for i in selectionsTuple:
            print i, self.myListbox.get(i)
            
# end class Application

myApp = Application()
myApp.mainloop()
